<?php
// +----------------------------------------------------------------------+
// | Copyright (c) SiouxApp - All Rights Reserved                         |
// | Unauthorized copying of this file, via any medium is prohibited.     |
// | Proprietary and confidential - Written by Michael P. Hofmann         |
// +----------------------------------------------------------------------+
// ------------------------------------------------------------------------
function __sapperror($errno, $errstr, $errfile, $errline) {
    if(error_reporting()==0) // to support @
        return;
    $errtitles = array('1' => 'System Error', '2' => 'System Warning', '4' => 'System Parse Error', '8' => 'System Notice', '16' => 'System Core Error', '32' => 'System Core Warning', '64' => 'System Compile Error', '128' => 'System Compile Warning', '256' => 'Error', '512' => 'Warning', '1024' => 'Notice', '2048' => 'Strict', '4096' => 'Recoverable Error', '6143' => 'All', '8192' => 'Deprecated', '30719' => 'All', '6143' => 'All');
    $inLine = "{$errtitles[$errno]}: $errstr ($errfile / $errline)\n";
    echo $inLine;
    if(defined('PATH_LOG'))
        @file_put_contents(PATH_LOG.'error.log', date('Y-m-d H:i:s').": $inLine", FILE_APPEND);
}
// ------------------------------------------------------------------------
function __autoload($classname) {
    $classname = strtolower($classname);
    $paths = array(
        dirname(__FILE__).'/../../inc/control/',
        dirname(__FILE__).'/../../inc/data/',
        dirname(__FILE__).'/../../inc/util/',
        dirname(__FILE__).'/../../inc/object/',
        dirname(__FILE__).'/../../inc/gui/',
        dirname(__FILE__).'/../../lib/');
    foreach($paths as $path){
        foreach(scandir($path) as $dir){
            $pathfile = "{$path}{$dir}/{$classname}.inc";
            if(file_exists($pathfile)){
                include_once($pathfile);
                if(method_exists($classname, '__constructStatic'))
                    $classname::__constructStatic();
                return true;
            }
        }
    }
    return false;
}
// ------------------------------------------------------------------------
function __sappconstantdefine() {
    $constants = array();
    // PATH_OPT/sapp-common/config/etc
    foreach(scandir(dirname(__FILE__).'/../../config/etc/') as $file){
        if(substr($file, 0, 1)=='.')
            continue;
        $constants = array_merge($constants, __sapputilparseiniget(dirname(__FILE__).'/../../config/etc/'.$file));
    }
    // CLI etc-addon
    if(stripos(php_sapi_name(), 'CLI')!==false){
        // config-10infralinux
        $filepath = $constants['PATH_OPT']."sapp-common/config/etc-addon/config-10infralinux".strtolower(__sappinfralinuxtypeget()).".ini";
        if(file_exists($filepath)){
            $constants = array_merge($constants, __sapputilparseiniget($filepath));
        }
        // config-50partner
        if(file_exists($constants['PATH_ETC'].'.partner-id')){
            $partner = trim(file_get_contents($constants['PATH_ETC'].'.partner-id'));
            $filepath = $constants['PATH_OPT']."sapp-common/config/etc-addon/config-50partner{$partner}.ini";
            if(file_exists($filepath))
                $constants = array_merge($constants, __sapputilparseiniget($filepath));
        }
    }
    // PATH_ETC
    foreach(scandir($constants['PATH_ETC']) as $file){
        if(substr($file, 0, 1)=='.')
            continue;
        if(substr($file, 0, 6)!=='config' and substr($file, -4)!=='.ini')
            continue;
        $constants = array_merge($constants, __sapputilparseiniget($constants['PATH_ETC'].$file));
    }
    foreach($constants as $id => $val){
        if( ! defined($id)){
            if(substr($id, 0, strlen('PATH_'))=='PATH_')
                $val = (substr($val, -1)=='/') ? $val : $val.'/';
            define($id, trim($val));
        }
    }
}
// ------------------------------------------------------------------------
function __sapputilparseiniget($inFilepath) {
    $return = array();
    $ar = @parse_ini_file($inFilepath);
    if(is_array($ar)){
        foreach($ar as $id => $val){
            if(substr($id, 0, strlen('path_'))=='path_')
                $val = (substr($val, -1)=='/') ? $val : $val.'/';
            $return[strtoupper($id)] = $val;
        }
    }
    return $return;
}
// ------------------------------------------------------------------------
function __sappinfralinuxtypeget() {
    if(stripos(php_uname(), 'UCS')!==false)
        $return = 'UCS';
    elseif(stripos(php_uname(), 'Ubuntu')!==false)
        $return = 'Ubuntu';
    elseif(stripos(php_uname(), 'Debian')!==false or file_exists('/etc/debian_version')!==false)
        $return = 'Debian';
    elseif(strtoupper(substr(PHP_OS, 0, 5))=='LINUX')
        $return = 'Linux';
    elseif(strtoupper(substr(PHP_OS, 0, 3))=='WIN')
        $return = 'Windows';
    return $return;
}
// EXECUTE ----------------------------------------------------------------
set_error_handler('__sapperror');
ignore_user_abort(true);
__sappconstantdefine();
ini_set('log_errors', '1');
ini_set('error_log', PATH_LOG.'error.log');
ini_set('display_errors', '1');
// ------------------------------------------------------------------------
?>