<?php
// +----------------------------------------------------------------------+
// | Copyright (c) SiouxApp - All Rights Reserved                         |
// | Unauthorized copying of this file, via any medium is prohibited.     |
// | Proprietary and confidential - Written by Michael P. Hofmann         |
// +----------------------------------------------------------------------+
class SappIncHttp {
    // --------------------------------------------------------------------
    public static function Exec($inAction = '') {
        if(empty($inAction))
            return;
        switch($inAction){
            case 'redirect-123':
            case 'redirect-check':
                $domain = self::__UrlDomainGet();
                $redirect = self::__DomainSiteAppRedirectGet($domain);
                $redirect = (empty($redirect)) ? self::__DomainConfigRedirectGet($domain) : $redirect;
                if( ! empty($redirect) and $redirect!=$domain){
                    // copy of PathLog::DomainAppend
                    $filepath = PATH_LOG.'domain-'.$domain;
                    $str = '';
                    if( ! file_exists($filepath))
                        $str.= date('Y-m-d').':';
                    elseif(date('Y-m-d')>date('Y-m-d', @filemtime($filepath)))
                        $str.= "\n".date('Y-m-d').':';
                    $array = array(
                        '00' => '0', '01' => '1', '02' => '3', '03' => '3', '04' => '4', '05' => '5', '06' => '6', '07' => '7', '08' => '8', '09' => '9', '10' => 'a', '11' => 'b',
                        '12' => 'c', '13' => 'd', '14' => 'e', '15' => 'f', '16' => 'g', '17' => 'h', '18' => 'i', '19' => 'j', '20' => 'k', '21' => 'l', '22' => 'm', '23' => 'n',
                    );
                    $str.= $array[date('H')];
                    @file_put_contents($filepath, $str, FILE_APPEND);
                    // redirect
                    $proto = self::__UrlSelfProtocolGet();
                    header("Location: $proto://$redirect");
                    exit;
                }
                if($inAction=='redirect-123'){
                    header("Location: ".self::__HeaderLocationGet(SITE_DEFAULT, SYSTEM_APP_DEFAULT));
                    exit;
                }
                break;
            case 'redirect-ssl':
                header("Location: https://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"]);
                exit;
            case 'redirect-app':
                $site = SITE_DEFAULT;
                $app = SYSTEM_APP_DEFAULT;
                $app = (empty($_GET['app'])) ? $app : $_GET['app'];
                $site = (file_exists(PATH_DATA."test/$app")) ? 'test' : $site;
                $site = (file_exists(PATH_DATA."home/$app")) ? 'home' : $site;
                header("Location: ".self::__HeaderLocationGet($site, $app));
                exit;
        }
    }
    // --------------------------------------------------------------------
    private static function __DomainSiteAppRedirectGet($inDomain) {
        $return = '';
        if(file_exists(PATH_ETC.'.data-siteapp.ini')){
            foreach(parse_ini_file(PATH_ETC.'.data-siteapp.ini') as $id => $val){
                if(substr($id, -strlen('_domain'))!='_domain')
                    continue;
                if($inDomain==$val){
                    $domain = self::__InfraSappDomainGet();
                    $pieces = explode('_',$id);
                    $return = (empty($domain)) ? $return : "{$domain}/sapp/{$pieces[1]}";
                }
            }
        }
        return $return;
    }
    // --------------------------------------------------------------------
    private static function __InfraSappDomainGet() {
        $return = '';
        $ar = array();
        foreach(scandir(PATH_LOG) as $file){
            if(substr($file, 0, strlen('domain-'))=='domain-')
                $ar[filesize(PATH_LOG.$file)] = substr($file, strlen('domain-'));
        }
        if( ! empty($ar)){
            ksort($ar);
            $return = end($ar);
        }
        return $return;
    }
    // --------------------------------------------------------------------
    private static function __DomainConfigRedirectGet($inDomain) {
        $return = '';
        if(file_exists(PATH_ETC.'domain-redirect.ini')){
            $inis = parse_ini_file(PATH_ETC.'domain-redirect.ini');
            $return = @$inis[$inDomain];
        }
        return $return;
    }
    // --------------------------------------------------------------------    
    private static function __HeaderLocationGet($inSite, $inApp) {
        $proto = @(( ! empty($_SERVER['HTTPS']) and $_SERVER['HTTPS']!=='off') or $_SERVER['SERVER_PORT']==443) ? 'https' : 'http';
        $path = '/'.str_replace(SYSTEM_PATH_WWW, '', PATH_WWW)."{$inSite}-{$inApp}";
        return "{$proto}://".@$_SERVER["HTTP_HOST"].$path;
    }
    // --------------------------------------------------------------------    
    private static function __UrlDomainGet() {
        $return = '';
        if( ! empty($_SERVER['SERVER_NAME']))
            $return = $_SERVER['SERVER_NAME'];
        elseif( ! empty($_SERVER['REQUEST_URI']))
            $return = parse_url($_SERVER['REQUEST_URI'], PHP_URL_HOST);
        return $return;
    }
    // --------------------------------------------------------------------
    private static function __UrlSelfProtocolGet() {
        @$return = (( ! empty($_SERVER['HTTPS']) and $_SERVER['HTTPS']!=='off') or $_SERVER['SERVER_PORT']==443) ? 'https' : 'http';
        return $return;
    }
    // --------------------------------------------------------------------
}
?>